/*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
   MODULO MySQL                                                                  
   Programado por Lucas Priori                                                   
   Versao: 1.1                                                                   
                                                                                 
  Linux:                                                                         
  32 Bits: gcc -shared -nostartfiles selor_mysql.c -o selor_mysql.so -lcrypt -lmysqlclient -Wall
  64 Bits: gcc -shared -nostartfiles selor_mysql.c -o selor_mysql.so -DA64 -lcrypt -lmysqlclient -Wall -fPIC
                                                                                 
  FreeBSD:                                                                       
  32 Bits: gcc -shared -nostartfiles selor_mysql.c -o selor_mysql.so -L/usr/local/lib/mysql -DFreeBSD -lmysqlclient -Wall
  64 Bits: gcc -shared -nostartfiles selor_mysql.c -o selor_mysql.so -L/usr/local/lib/mysql -DFreeBSD -DA64 -lmysqlclient -Wall -fPIC
                                                                                 
  ****************************************************************************** 
  Este programa  um modulo MySQL para o MTA SELOR                               
  Copyright (C) 2012,2013,2014  Lucas Priori                                     
                                                                                 
  This program is free software; you can redistribute it and/or                  
  modify it under the terms of the GNU General Public License                    
  as published by the Free Software Foundation; either version 2                 
  of the License, or (at your option) any later version.                         
                                                                                 
  This program is distributed in the hope that it will be useful,                
  but WITHOUT ANY WARRANTY; without even the implied warranty of                 
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                  
  GNU General Public License for more details.                                   
                                                                                 
  You should have received a copy of the GNU General Public License              
  along with this program; if not, write to the Free Software                    
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/

#include<stdio.h>
#include<stdlib.h>
#include<fcntl.h>
#include<string.h>
#include<unistd.h>
#include<sys/ipc.h>
#include<sys/sem.h>
#include<errno.h>
#ifdef FreeBSD
 #include<rpcsvc/crypt.h>
 #include "/usr/local/include/mysql/mysql.h"
 #include "/usr/local/include/mysql/errmsg.h"
#else
 #include<crypt.h>
 #include<mysql/mysql.h>
 #include<mysql/errmsg.h>
#endif

#define MAX_cnx 30
#define MOD_NAME "mysql\0"
#define VERSAO "1.1\0"
#define TAM_buffer 2048
#define TAM_msg_error 200
#define TAM_user 250
#define TAM_pass 250
#define TAM_home 500
#define TAM_dlocal 500
#define TAM_maildir 100
#define ALIAS_LIMIT 10
#define MAILDIRSIZE 1
#define MAILBOX 2
#define MAX_ptr_quota 5
#define MOD_user_user 0
#define MOD_user_pass 1
#define MOD_user_home 2
#define MOD_user_dlocal 3
#define TH_sleep_time 600  // 10 minutos


//---------------------------------------------------
//      Variaveis GLOBAIS                            
//---------------------------------------------------
MYSQL *mysql[MAX_cnx+1];
MYSQL_RES *myres; 
MYSQL_ROW myreg;
char buffer[TAM_buffer + 1];
char linha[TAM_buffer + 1];
char msg_error[TAM_msg_error + 1];
char ret=0;
int arq_quota=0;
unsigned int num_registros=0;
unsigned int num_alias=0;
// --- DADOS DE CONEXAO ---
char mod_name[50]=MOD_NAME;
char host[100]={0};
char db[100]={0};
char user[100]={0};
char pass[100]={0};
char user_table[100]={0};
char user_login_field[100]={0};
char user_pass_field[100]={0};
char user_home_field[100]={0};
char user_maildir_field[100]={0};
char user_quota_field[100]={0};
char user_dlocal_field[100]={0};
char user_force_alias_field[100]={0};
char user_pass_type[50]={0};
char auth_where_clause[1000]={0};
char domain_table[100]={0};
char domain_field[100]={0};
char alias_table[100]={0};
char alias_field[100]={0};
char alias_rcpt_field[100]={0};
char adomain_table[100]={0};
char adomain_field[100]={0};
char adomain_domain_field[100]={0};
char adomain_alias_seek=0;
char where_clause[100]={0};
char broadcast_where_clause[100]={0};
int num_cnx=5;
// ---
char maildirsize=1;
char quota_type=MAILDIRSIZE;
// --- CACHE DE USUARIO ---
char cache_user[TAM_user]={0};
char cache_pass[TAM_pass]={0};
char cache_home[TAM_home]={0};
char cache_dlocal[TAM_dlocal]={0};
char cache_maildir[TAM_maildir]={0};
char cache_force_alias=0;
unsigned long long int cache_quota=0;
// ---
char auth_ativo=0;
char linha_quota[100];
short sem_num=0;
short atual_cnx=0;               // Variavel que armazena a atual conexao mysql
unsigned int cont1=0;
unsigned int cont2=0;
unsigned int cont3=0;
int b_lidos=0;
int tam_user=0;
long long int tam=0;
long long int num=0;
// --- Semaforo ---
key_t chave;
#ifdef FreeBSD
 union semun sm_ctl;
#else
 union semun {
     int val;
     struct semid_ds *buf;
     unsigned short  *array;
 }sm_ctl;
#endif
struct sembuf sm_travar,sm_liberar;
int semid;

// Funcoes chamadas pela DLlib. Obrigatorias
void _init();  // Chamada quando o modulo  carregado 
void _fini();  // Chamada quando o modulo  desativado


// =========================
//  Funcoes uteis do modulo 
// =========================

//---------------------------------------------------
//Funcao para comparar duas strings desconciderando  
//a diferena entre maiusculas e minusculas          
//Retornos:                                          
//0 = strings so iguais                             
//1 = strings so diferentes                         
int cmp_str(char *string1, char *string2, int num_bytes){
 if(!num_bytes){
  if(*string1==*string2)return 0;
  return 1;
 }
 int ret_val=0;
 #ifdef A64
  asm(
   "mov  %0,%%rdi           \n"
   "mov  %1,%%rsi           \n"
  "CMP_STR_proxbyte:        \n"
   "movb (%%rsi),%%al       \n"
   "cmpb (%%rdi),%%al       \n"
   "jne  CMP_STR_trocar     \n"
  "CMP_STR_incr:            \n"
   "inc  %%rsi              \n"
   "inc  %%rdi              \n"
   "loop CMP_STR_proxbyte   \n"
   "jmp  CMP_STR_term       \n"
  "CMP_STR_trocar:          \n"
   "xorb $32,%%al           \n"
   "cmpb (%%rdi),%%al       \n"
   "je   CMP_STR_incr       \n"
  "CMP_STR_term:            \n"
   "testw %%cx,%%cx         \n"
   "jz   CMP_STR_fim        \n"
   "movw $1,%%cx            \n"
  "CMP_STR_fim:             \n"
   "movw  %%cx,%3           \n"
   :
   :"m"(string1),"m"(string2),"c"(num_bytes),"m"(ret_val)
   :"rdi","rsi","rax"
  );
 #else
  asm(
   "movl %0,%%edi           \n"
   "movl %1,%%esi           \n"
  "CMP_STR_proxbyte:        \n"
   "movb (%%esi),%%al       \n"
   "cmpb (%%edi),%%al       \n"
   "jne  CMP_STR_trocar     \n"
  "CMP_STR_incr:            \n"
   "incl %%esi              \n"
   "incl %%edi              \n"
   "loop CMP_STR_proxbyte   \n"
   "jmp  CMP_STR_term       \n"
  "CMP_STR_trocar:          \n"
   "xorb $32,%%al           \n"
   "cmpb (%%edi),%%al       \n"
   "je   CMP_STR_incr       \n"
  "CMP_STR_term:            \n"
   "testw %%cx,%%cx         \n"
   "jz   CMP_STR_fim        \n"
   "movw $1,%%cx            \n"
  "CMP_STR_fim:             \n"
   "movw  %%cx,%3           \n"
   :
   :"m"(string1),"m"(string2),"c"(num_bytes),"m"(ret_val)
   :"edi","esi","eax"
  );
 #endif
 return ret_val;
}

//---------------------------------------------------
// Funcao semelhante a strncpy, porem, retorna o     
// numero de bytes copiados, pra quando encontra    
// ZERO e tem                                        
// protecao contra buffer overflow                   
unsigned int local_strncpy(char *destino, char *origem, unsigned int tam_str){
 unsigned int ret_val;
 
 
 #ifdef A64
   asm(
   "mov  %0,%%rdi           \n"
   "mov  %1,%%rsi           \n"
   "mov  %%rsi,%%rbx        \n"
  "STRNCPY_prox:            \n"
   "lodsb                   \n"
   "stosb                   \n"
   "testb $255,%%al         \n"
   "jz    STRNCPY_fim       \n"
   "loop  STRNCPY_prox      \n"
   "inc  %%rsi              \n"
  "STRNCPY_fim:             \n"
   "movb  $0,(%%rdi)        \n"
   "sub  %%rbx,%%rsi        \n"
   "dec  %%esi              \n"   
   "mov  %%esi,%3           \n"
   :
   :"m"(destino), "m"(origem), "c"(tam_str), "m"(ret_val)
   :"rdi", "rsi", "rax", "rbx"
  );
 #else
  asm(
   "movl  %0,%%edi          \n"
   "movl  %1,%%esi          \n"
   "movl  %%esi,%%ebx       \n"
  "STRNCPY_prox:            \n"
   "lodsb                   \n"
   "stosb                   \n"
   "testb $255,%%al         \n"
   "jz    STRNCPY_fim       \n"
   "loop  STRNCPY_prox      \n"
   "incl  %%esi             \n"
  "STRNCPY_fim:             \n"
   "movb  $0,(%%edi)        \n"
   "subl  %%ebx,%%esi       \n"
   "decl  %%esi             \n"   
   "movl  %%esi,%3          \n"
   :
   :"m"(destino), "m"(origem), "c"(tam_str), "m"(ret_val)
   :"edi", "esi", "eax" , "ebx"
  );
 #endif
 
 return ret_val;
}


//---------------------------------------------------
// Copia uma string  com variaveis                   
void cp_str_var(char *destino, int tam_dest, char *origem, char *ptr_usr){
 int b_copiados=0;
 
 while(*origem && tam_dest > 1){
  if(*origem == '%'){
   if(*++origem == 'u'){
    b_copiados=local_strncpy(destino, ptr_usr, tam_dest);  // Usuario
    destino+=b_copiados;
    tam_dest-=b_copiados;
   }else {
    *destino++=*origem;
    if(!*origem)return;
   }
   origem++;
  }else *destino++=*origem++;
 }
 if(tam_dest < 1)*destino=0;
 else *destino=*origem;
}


//======================================================
// Funcao que pega uma conexao mysql disponivel         
void get_free_cnx(void){
 
 if(atual_cnx == MAX_cnx)return;              // Se atual_cnx = MAX_cnx, significa que ja foi crida
                                              // uma conexao extra para atender a este modulo e nos
                                              // a usaremos at o fim do processo                  
 for(sem_num=0; sem_num<num_cnx; sem_num++){
  sm_travar.sem_num=sem_num;
  if(!(semop(semid, &sm_travar, 1))){
   atual_cnx=sem_num;
   return;
  }
 }
 // Nenhuma conexao disponivel. Vamos criar uma e retorna-la em mysql[MAX_cnx]                                       
 mysql_real_connect(mysql[MAX_cnx], host, user, pass, db, 0, NULL, 0);
 atual_cnx=MAX_cnx;
}


//======================================================
// Funcao para liberar uma conexao                      
void free_cnx(void){
 
 if(atual_cnx < MAX_cnx){                   // Liberar apenas um semaforo
  sm_liberar.sem_num=atual_cnx;             // Caso a conexao tenha sido aberta em mysql[MAX_cnx]
  semop(semid, &sm_liberar, 1);             // vamos usa-la ate o fim do processo correte e sera 
 }                                          // fechada automaticamente com o processo morrer     
}


//======================================================
// Funcao para executar uma query MySQL. Em caso de     
// falha na conexao, ela tenta conectar novamente       
// Retornos:                                            
// 0 -> Query executada com sucesso                     
// -1 -> Erro MySQL                                     
char local_mysql_query(char *cmd_sql){
 
 if(mysql_query(mysql[atual_cnx], cmd_sql)){
  // -- Ocorreu um ERRO --
  if(mysql_errno(mysql[atual_cnx]) == CR_SERVER_GONE_ERROR){
   if(mysql_real_connect(mysql[atual_cnx], host, user, pass, db, 0, NULL, 0) && !mysql_query(mysql[atual_cnx], cmd_sql))return 0;        // --> Tentando conectar novamente
  }
  return -1;
 }
 return 0;
}

//======================================================
// Reliza a conversao de um dominio alias               
// Retornos:                                            
// 0 = Nada encontrado                                  
// 1 = Dominio encontrado e esta em myreg[0]            
// -1 = Erro executando comando MySQL                   
char conv_adomain(char *adomain){
 
 // get_free_cnx() nao e usada aqui pois  travado por fora
 snprintf(buffer, TAM_buffer, "SELECT %s FROM %s WHERE %s='%s'", adomain_domain_field, adomain_table, adomain_field, adomain);
 if(!mysql_query(mysql[atual_cnx], buffer)){
  myres=mysql_store_result(mysql[atual_cnx]);
  if(myres){
   if((myreg=mysql_fetch_row(myres))){
    return 1;
   }
   return 0;
  }
 }
 return -1;
}



// =========================
//     Funcoes do MODULO    
// =========================

//======================================================
// Funcao chamada pelo MTA assim que  carregado. Igual 
// a _init, porm, aceita um parametro que pode ser um  
// arquivo de configuracao a ler.  o parametro passado 
// dentro do selor.conf                                 
// Retornos:                                            
// 0 = Sem erros, modulo carregado                      
// 1 = Erro                                             
char mod_init(char *param, char *module_name, char *module_version, char *info, int info_buf_size){
 FILE *arq_conf;
 char *ptr;
 int b_lidos=0;
 unsigned int cont1=0;
 unsigned int cont2=0;
 
 // Abrindo arquivo de configurao
 if(!param){
  strcpy(msg_error, "You must specify a configuration file");
  return 1;
 }
 arq_conf=fopen(param, "rb");
 if(!arq_conf){
  snprintf(msg_error, TAM_msg_error, "File not found [%s]", param);
  return 1;
 }
 while(!feof(arq_conf)){
  b_lidos=fread(&buffer, 1, TAM_buffer, arq_conf);
  for(cont1=0; cont1<b_lidos; cont1++){
   if(buffer[cont1] == 10){
    linha[cont2]=0;
    if(!cont2)continue;
    if(linha[0] == '#'){
     cont2=0;
     continue;
    }
    if(!cmp_str(linha, "mod_name=", 9)){
     // -- MOD_NAME --
     ptr=&linha[9];
     while(*ptr == ' ' || *ptr == 9)ptr++;
     strncpy(mod_name, ptr, sizeof(mod_name));
    }else if(!cmp_str(linha, "host=", 5)){
     // -- HOST -- 
     ptr=&linha[5];
     while(*ptr == ' ' || *ptr == 9)ptr++;
     strncpy(host, ptr, sizeof(host));
    }else if(!cmp_str(linha, "db=", 3)){
     // -- DB --
     ptr=&linha[3];
     while(*ptr == ' ' || *ptr == 9)ptr++;
     strncpy(db, ptr, sizeof(db));
    }else if(!cmp_str(linha, "user=", 5)){
     // -- USER --
     ptr=&linha[5];
     while(*ptr == ' ' || *ptr == 9)ptr++;
     strncpy(user, ptr, sizeof(user));
    }else if(!cmp_str(linha, "pass=", 5)){
     // -- PASS --
     ptr=&linha[5];
     while(*ptr == ' ' || *ptr == 9)ptr++;
     strncpy(pass, ptr, sizeof(pass));
    }else if(!cmp_str(linha, "num_cnx=", 8)){
     // -- NUM_CNX --
     ptr=&linha[8];
     while(*ptr == ' ' || *ptr == 9)ptr++;
     num_cnx=atoi(ptr);
     if(num_cnx >= MAX_cnx)num_cnx=MAX_cnx;
    }else if(!cmp_str(linha, "user_table=", 11)){
     // -- USER_TABLE --
     ptr=&linha[11];
     while(*ptr == ' ' || *ptr == 9)ptr++;
     strncpy(user_table, ptr, sizeof(user_table));
    }else if(!cmp_str(linha, "user_login_field=", 17)){
     // -- USER_LOGIN_FIELD --
     ptr=&linha[17];
     while(*ptr == ' ' || *ptr == 9)ptr++;
     strncpy(user_login_field, ptr, sizeof(user_login_field));
    }else if(!cmp_str(linha, "user_pass_field=", 16)){
     // -- USER_PASS_FIELD --
     ptr=&linha[16];
     while(*ptr == ' ' || *ptr == 9)ptr++;
     strncpy(user_pass_field, ptr, sizeof(user_pass_field));
    }else if(!cmp_str(linha, "user_home_field=", 16)){
     // -- USER_HOME_FIELD --
     ptr=&linha[16];
     while(*ptr == ' ' || *ptr == 9)ptr++;
     strncpy(user_home_field, ptr, sizeof(user_home_field));
    }else if(!cmp_str(linha, "user_maildir_field=", 19)){
     // -- USER_MALDIR_FIELD --
     ptr=&linha[19];
     while(*ptr == ' ' || *ptr == 9)ptr++;
     strncpy(user_maildir_field, ptr, sizeof(user_maildir_field));
    }else if(!cmp_str(linha, "user_quota_field=", 17)){
     // -- USER_QUOTA_FIELD --
     ptr=&linha[17];
     while(*ptr == ' ' || *ptr == 9)ptr++;
     strncpy(user_quota_field, ptr, sizeof(user_quota_field));
    }else if(!cmp_str(linha, "user_dlocal_field=", 18)){
     // -- USER_DLOCAL_FIELD --
     ptr=&linha[18];
     while(*ptr == ' ' || *ptr == 9)ptr++;
     strncpy(user_dlocal_field, ptr, sizeof(user_dlocal_field));
    }else if(!cmp_str(linha, "user_force_alias_field=", 23)){
     // -- USER_FORCE_ALIAS_FIELD --
     ptr=&linha[23];
     while(*ptr == ' ' || *ptr == 9)ptr++;
     strncpy(user_force_alias_field, ptr, sizeof(user_force_alias_field));
    }else if(!cmp_str(linha, "user_pass_type=", 15)){
     // -- USER_PASS_TYPE --
     ptr=&linha[15];
     while(*ptr == ' ' || *ptr == 9)ptr++;
     strncpy(user_pass_type, ptr, sizeof(user_pass_type));
    }else if(!cmp_str(linha, "domain_table=", 13)){
     // -- DOMAIN_TABLE --
     ptr=&linha[13];
     while(*ptr == ' ' || *ptr == 9)ptr++;
     strncpy(domain_table, ptr, sizeof(domain_table));
    }else if(!cmp_str(linha, "domain_field=", 13)){
     // -- DOMAIN_FIELD --
     ptr=&linha[13];
     while(*ptr == ' ' || *ptr == 9)ptr++;
     strncpy(domain_field, ptr, sizeof(domain_field));
    }else if(!cmp_str(linha, "alias_table=", 12)){
     // -- ALIAS_TABLE --
     ptr=&linha[12];
     while(*ptr == ' ' || *ptr == 9)ptr++;
     strncpy(alias_table, ptr, sizeof(alias_table));
    }else if(!cmp_str(linha, "alias_field=", 12)){
     // -- ALIAS_FIELD --
     ptr=&linha[12];
     while(*ptr == ' ' || *ptr == 9)ptr++;
     strncpy(alias_field, ptr, sizeof(alias_field));
    }else if(!cmp_str(linha, "alias_rcpt_field=", 17)){
     // -- ALIAS_RCPT_FIELD --
     ptr=&linha[17];
     while(*ptr == ' ' || *ptr == 9)ptr++;
     strncpy(alias_rcpt_field, ptr, sizeof(alias_rcpt_field));
    }else if(!cmp_str(linha, "adomain_table=", 14)){
     // -- ADOMAIN_TABLE --
     ptr=&linha[14];
     while(*ptr == ' ' || *ptr == 9)ptr++;
     strncpy(adomain_table, ptr, sizeof(adomain_table));
    }else if(!cmp_str(linha, "adomain_field=", 14)){
     // -- ADOMAIN_FIELD --
     ptr=&linha[14];
     while(*ptr == ' ' || *ptr == 9)ptr++;
     strncpy(adomain_field, ptr, sizeof(adomain_field));
    }else if(!cmp_str(linha, "adomain_domain_field=", 21)){
     // -- ADOMAIN_DOMAIN_FIELD --
     ptr=&linha[21];
     while(*ptr == ' ' || *ptr == 9)ptr++;
     strncpy(adomain_domain_field, ptr, sizeof(adomain_field));
    }else if(!cmp_str(linha, "adomain_alias_seek=", 19)){
     // -- ADOMAIN_ALIAS_SEEK --
     ptr=&linha[19];
     while(*ptr == ' ' || *ptr == 9)ptr++;
     if(!cmp_str(ptr, "yes\0", 4))adomain_alias_seek=1;
     else if(!strcmp(ptr, "1"))adomain_alias_seek=1;
     else if(!cmp_str(ptr, "on\0", 3))adomain_alias_seek=1;
     else if(!cmp_str(ptr, "enable\0", 7))adomain_alias_seek=1;
    }else if(!cmp_str(linha, "where_clause=", 13)){
     // -- WHERE CLAUSE --
     ptr=&linha[13];
     while(*ptr == ' ' || *ptr == 9)ptr++;
     snprintf(where_clause, sizeof(where_clause)-1, "AND %s", ptr);
    }else if(!cmp_str(linha, "auth_where_clause=", 18)){
     // -- AUTH_WHERE_CLAUSE --
     ptr=&linha[18];
     while(*ptr == ' ' || *ptr == 9)ptr++;
     snprintf(auth_where_clause, sizeof(auth_where_clause)-1, "AND %s", ptr);
    }else if(!cmp_str(linha, "broadcast_where_clause=", 23)){
     // -- BROADCAST_WHERE_CLAUSE --
     ptr=&linha[23];
     while(*ptr == ' ' || *ptr == 9)ptr++;
     snprintf(broadcast_where_clause, sizeof(broadcast_where_clause)-1, "AND %s", ptr);
    }else if(!cmp_str(linha, "quota_type=", 11)){
     // -- QUOTA_TYPE --
     ptr=&linha[11];
     while(*ptr == ' ' || *ptr == 9)ptr++;
     if(!cmp_str(ptr, "maildirsize\0", 12)){
      // MAILDIRSIZE
      quota_type=1;
     }else {
      snprintf(msg_error, TAM_msg_error, "Invalid quota_type [%s]", ptr);
      return 1;
     }
    }else {
     snprintf(msg_error, TAM_msg_error, "Invalid option [%s]", linha);
     return 1;
    }
    cont2=0;
   }else if(buffer[cont1] != 13)linha[cont2++]=buffer[cont1];
  }
 }
 fclose(arq_conf);
 
 if(num_cnx){
  chave=ftok(param, 'S');
  if((semid=semget(chave, 0, 0660)) != -1){
   // Semaforo ja existe. Vamos remove-lo para criar novamente
   semctl(semid, 0, IPC_RMID, NULL);
  }
  
  // Abrindo semaforo para controlar as conexoes
  if((semid=semget(chave, num_cnx, 0660 | IPC_CREAT)) == -1){
   Sem_error:
   strcpy(msg_error, "Error creating semaphore");
   return 1;
  }
  // Liberando os semaforos com valores positivos
  sm_ctl.val=1;
  for(cont1=0; cont1<num_cnx; cont1++)if(semctl(semid, cont1, SETVAL, sm_ctl))goto Sem_error;
  
  sm_travar.sem_op=-1;
  sm_travar.sem_flg=IPC_NOWAIT | SEM_UNDO;
  sm_liberar.sem_op=1;
  sm_liberar.sem_flg=IPC_NOWAIT | SEM_UNDO;
  
  // -- Abrindo as conexoes com o Banco de Dados --
  for(cont1=0; cont1<num_cnx; cont1++){
   mysql[cont1] = mysql_init(NULL);
   if(!mysql[cont1]){
    strcpy(msg_error, "Mysql_init() Fail");
    return 1;
   }
   // Conectando-se ao banco de dados
   mysql_real_connect(mysql[cont1], host, user, pass, db, 0, NULL, 0);
  }
 }
 mysql[MAX_cnx]=mysql_init(NULL);  // Preparando o ultimo para ficar  
                                   // de prontidao para atender quando
                                   // o modulo nao encontrar cnxs disponiveis
 
 strcpy(module_name, mod_name);
 strcpy(module_version, VERSAO);
 return 0;
}


//======================================================
// Checa e reativa as conexoes com o banco de dados     
char mod_cnx_refresh(void){
 unsigned int sem_num=0;
 int ret1;
 
 if(!getuid()){
  for(sem_num=0; sem_num < num_cnx; sem_num++){
   sm_travar.sem_num=sem_num;
   if(!(semop(semid, &sm_travar, 1))){
    // Semaforo travado
    ret1=mysql_ping(mysql[sem_num]);
    if(ret1){
     // -- Conexao fora --
     mysql_real_connect(mysql[sem_num], host, user, pass, db, 0, NULL, 0);
    }
    // Liberando semaforo
    sm_liberar.sem_num=sem_num;
    semop(semid, &sm_liberar, 1);
   }
  }
 }
 return 0;
}



//======================================================
// Checa se o dominio  local ou nao                    
// Retornos:                                            
// 0 = Nao  local                                      
// 1 = Dominio  local                                  
// -1 = Erro                                            
char mod_dom_local(char *dominio, char *ret_dom){
 
 // Apenas para testes
 //printf("MYSQL: mod_dom_local(%s)\n", dominio);
 snprintf(buffer, TAM_buffer, "SELECT %s FROM %s WHERE %s='%s'", domain_field, domain_table, domain_field, dominio);
 get_free_cnx();
 if(!local_mysql_query(buffer)){
  if((myres=mysql_store_result(mysql[atual_cnx]))){
   num_registros=mysql_num_rows(myres);
   mysql_free_result(myres);
   free_cnx();
   if(num_registros){
    *ret_dom=0;       // Para indicar que nao  um dominio alias (OBRIGATORIO)
    return 1;         // --> Dominio LOCAL      
   }
   if(adomain_table[0]){
    // Nao existe. Vamos procurar na tabela ADOMAIN
    get_free_cnx();
    if(!(ret=conv_adomain(dominio))){
     mysql_free_result(myres);
     free_cnx();
     return 0;  // --> Dominio inexistente
    }
    if(ret == 1){
     if(myreg[0])strcpy(ret_dom, myreg[0]);  // Para retornar o verdadeiro dominio
     mysql_free_result(myres);
     free_cnx();
     return 1;
    }
   }else return 0;
  }
 }
 free_cnx();
 snprintf(msg_error, TAM_msg_error, "MySQL [%s]", mysql_error(mysql[atual_cnx]));
 return -1;
}

//======================================================
// Checa se o email  local ou nao                      
// Retornos:                                            
// 0 = Email nao existe                                 
// 1 = Email exite                                      
// 2 = Email existe e forcar uma busca na tab alias     
// -1 = Erro                                            
char mod_user_local(char *email, char *info[], int num_campos){   // num_campos  o numero de campos do vetor info[]. Por enquanto nao  usado 
 
 // Apenas para testes
 //printf("MYSQL: mod_user_local(%s)\n", email);
 if(!auth_ativo){
  if(!cmp_str(email, cache_user, tam_user+1)){
   // Email no cache
   info[MOD_user_user]=cache_user;
   info[MOD_user_pass]=cache_pass;
   info[MOD_user_home]=cache_home;
   if(user_dlocal_field[0])info[MOD_user_dlocal]=cache_dlocal;
   return cache_force_alias+1;
  }
  if(!user_force_alias_field[0]){
   if(!user_dlocal_field[0])snprintf(buffer, TAM_buffer, "SELECT %s,%s,%s,%s,%s FROM %s WHERE %s='%s' %s", user_login_field, user_pass_field, user_home_field, user_maildir_field, user_quota_field, user_table, user_login_field, email, where_clause);
   else snprintf(buffer, TAM_buffer, "SELECT %s,%s,%s,%s,%s,%s FROM %s WHERE %s='%s' %s", user_login_field, user_pass_field, user_home_field, user_maildir_field, user_quota_field, user_dlocal_field, user_table, user_login_field, email, where_clause);
  }else {
   
   if(!user_dlocal_field[0])snprintf(buffer, TAM_buffer, "SELECT %s,%s,%s,%s,%s,%s FROM %s WHERE %s='%s' %s", user_login_field, user_pass_field, user_home_field, user_maildir_field, user_quota_field, user_force_alias_field, user_table, user_login_field, email, where_clause);
   else snprintf(buffer, TAM_buffer, "SELECT %s,%s,%s,%s,%s,%s,%s FROM %s WHERE %s='%s' %s", user_login_field, user_pass_field, user_home_field, user_maildir_field, user_quota_field, user_dlocal_field, user_force_alias_field, user_table, user_login_field, email, where_clause);
  }
 }else {
  cp_str_var(linha, TAM_buffer, auth_where_clause, email);
  if(!user_force_alias_field[0]){
   if(!user_dlocal_field[0])snprintf(buffer, TAM_buffer, "SELECT %s,%s,%s,%s,%s FROM %s WHERE %s='%s' %s %s", user_login_field, user_pass_field, user_home_field, user_maildir_field, user_quota_field, user_table, user_login_field, email, where_clause, linha);
   else snprintf(buffer, TAM_buffer, "SELECT %s,%s,%s,%s,%s,%s FROM %s WHERE %s='%s' %s %s", user_login_field, user_pass_field, user_home_field, user_maildir_field, user_quota_field, user_dlocal_field, user_table, user_login_field, email, where_clause, linha);
  }else {
   if(!user_dlocal_field[0])snprintf(buffer, TAM_buffer, "SELECT %s,%s,%s,%s,%s,%s FROM %s WHERE %s='%s' %s %s", user_login_field, user_pass_field, user_home_field, user_maildir_field, user_quota_field, user_force_alias_field, user_table, user_login_field, email, where_clause, linha);
   else snprintf(buffer, TAM_buffer, "SELECT %s,%s,%s,%s,%s,%s,%s FROM %s WHERE %s='%s' %s %s", user_login_field, user_pass_field, user_home_field, user_maildir_field, user_quota_field, user_dlocal_field, user_force_alias_field, user_table, user_login_field, email, where_clause, linha);
  }
  auth_ativo=0;
 }
 
 get_free_cnx();
 if(!local_mysql_query(buffer)){
  if((myres=mysql_store_result(mysql[atual_cnx]))){
   if((myreg=mysql_fetch_row(myres))){
    cache_user[0]=cache_pass[0]=cache_home[0]=cache_maildir[0]=cache_dlocal[0]=cache_quota=cache_force_alias=0;
    tam_user=local_strncpy(cache_user, myreg[0], TAM_user);
    if(myreg[1])local_strncpy(cache_pass, myreg[1], TAM_pass);
    if(myreg[2])local_strncpy(cache_home, myreg[2], TAM_home);
    if(myreg[3])local_strncpy(cache_maildir, myreg[3], TAM_maildir);
    if(myreg[4])cache_quota=atoll(myreg[4]);
    if(user_dlocal_field[0]){
     if(myreg[5])local_strncpy(cache_dlocal, myreg[5], TAM_dlocal);
     info[MOD_user_dlocal]=cache_dlocal;
     if(user_force_alias_field[0] && myreg[6])cache_force_alias=(!atoi(myreg[6])^1);
    }else if(user_force_alias_field[0] && myreg[5])cache_force_alias=(!atoi(myreg[5])^1);
    mysql_free_result(myres);
    free_cnx();
    info[MOD_user_user]=cache_user;
    info[MOD_user_pass]=cache_pass;
    info[MOD_user_home]=cache_home;
    return cache_force_alias+1;
   }
   mysql_free_result(myres);
   free_cnx();
   return 0;
  }
 }
 free_cnx();
 snprintf(msg_error, TAM_msg_error, "MySQL [%s]", mysql_error(mysql[atual_cnx]));
 return -1;
}


//======================================================
// Retorna os alias                                     
// Retornos:                                            
// 0 = Nenhum alinas encontrado                         
// -1 = Erro                                            
// <numero de alias no buffer>                          
// Em: *prox_bloco, e' enviado o valor do proximo LIMIT 
int mod_ret_alias(char *email, char *buffer_ret, int num_itens, int tam_item_buffer, unsigned int *prox_bloco){
 
 snprintf(buffer, TAM_buffer, "SELECT %s FROM %s WHERE %s='%s' LIMIT %d,%d", alias_rcpt_field, alias_table, alias_field, email, *prox_bloco, num_itens);
 cont1=0;
 get_free_cnx();
 if(!local_mysql_query(buffer)){
  if((myres=mysql_store_result(mysql[atual_cnx]))){
   while((myreg=mysql_fetch_row(myres))){
    if(myreg[0])local_strncpy(buffer_ret, myreg[0], tam_item_buffer);
    else buffer_ret[0]=0;
    buffer_ret+=tam_item_buffer;
    cont1++;
   }
   mysql_free_result(myres);
  }
 }
 free_cnx();
 *prox_bloco+=cont1;       // Anotando o proximo bloco do LIMIT ao servidor
 return cont1;
}

//======================================================
// Retorna os emails de um dominio                      
// Retornos:                                            
// 0 = Nenhum email encontrado                          
// -1 = Erro                                            
// <numero de emails no buffer>                         
// Em: *prox_bloco, e' enviado o valor do proximo LIMIT 
int mod_ret_broadcast(char *dominio, char *buffer_ret, int num_itens, int tam_item_buffer, unsigned int *prox_bloco){
 
 snprintf(buffer, TAM_buffer, "SELECT %s FROM %s WHERE %s LIKE '%%@%s' %s LIMIT %d,%d", user_login_field, user_table, user_login_field, dominio, broadcast_where_clause, *prox_bloco, num_itens);
 cont1=0;
 get_free_cnx();
 if(!local_mysql_query(buffer)){
  if((myres=mysql_store_result(mysql[atual_cnx]))){
   while((myreg=mysql_fetch_row(myres))){
    if(myreg[0])local_strncpy(buffer_ret, myreg[0], tam_item_buffer);
    else buffer_ret[0]=0;
    buffer_ret+=tam_item_buffer;
    cont1++;
   }
   mysql_free_result(myres);
  }
 }
 free_cnx();
 *prox_bloco+=cont1;       // Anotando o proximo bloco do LIMIT ao servidor
 return cont1;
}



//======================================================
// Checa o usuario e senha passado                      
// Retornos:                                            
// 0 = Usuario nao encontrado                           
// 1 = Senha correta                                    
// 2 = Senha incorreta                                  
// -1 = Erro                                            
char mod_auth(char *email, char *senha, char *info[], int num_campos){
 
 // Apenas para testes
 //printf("MYSQL: mod_auth(%s, %s)\n", email, senha);
 
 auth_ativo=1;
 if(!(ret=mod_user_local(email, info, num_campos)))return 0; // Usurio nao existe
 else if(ret < 0)return ret;
 if(!cmp_str(user_pass_type, "crypt\0", 6)){
  // --- Modo de senha criptografada ---
  if(!strcmp((char *)crypt(senha, cache_pass), cache_pass))return 1;
  return 2;
 }
 // --- Modo de senha texto --- 
 if(!strcmp(senha, cache_pass))return 1;
 return 2;
}


//======================================================
// Checa o usuario e senha passado                      
// Retornos:                                            
// 0 = Usuario nao encontrado                           
// 1 = Quota nao excedida                               
// 2 = Quota excedida                                   
// -1 = Erro                                            
char mod_test_quota(char *email, char *info[], int num_campos){
 char num_linhas=0;
 long long int ttotal=0;
 long long int ntotal=0;
 
 // Apenas para testes
 //printf("MYSQL: mod_test_quota(%s)\n", email);
 if(!(ret=mod_user_local(email, info, num_campos)))return 0;
 else if(ret < 0)return ret;
 if(!cache_quota)return 1;
 snprintf(buffer, TAM_buffer, "%s/%s/maildirsize", cache_home, cache_maildir);
 arq_quota=open(buffer, O_RDWR | O_CREAT, 0666);
 if(arq_quota<0)return 1;        // Arquivo nao encontrado.
 cont2=0;
 do{
  b_lidos=read(arq_quota, buffer, TAM_buffer);
  for(cont1=0; cont1 < b_lidos; cont1++){
   if(buffer[cont1] == 10){
    linha[cont2]=0;
    if(!num_linhas)local_strncpy(linha_quota, linha, sizeof(linha_quota)-1);
    else {
     if(cont2 > 3){
      num_registros=sscanf(linha, "%lld %lld", &tam, &num);
      if(num_registros == 2){
       ttotal+=tam;
       ntotal+=num;
       if(ttotal < 0)ttotal=0;
       if(ntotal < 0)ntotal=0;
      }
     }
    }
    num_linhas++;
    cont2=0;
   }else if(buffer[cont1] != 13){
    linha[cont2]=buffer[cont1];
    cont2++;
   }
  }
 }while(b_lidos == TAM_buffer);
 if(num_linhas > 20 && !lockf(arq_quota, F_TLOCK, 0)){
  // Arquivo travado. Vamos resumi-lo
  b_lidos=sprintf(buffer, "%s\n%12lld %12lld\n", linha_quota, ttotal, ntotal);
  lseek(arq_quota, 0, 0);
  write(arq_quota, buffer, b_lidos);
  close(arq_quota);
  snprintf(buffer, TAM_buffer, "%s/%s/maildirsize", cache_home, cache_maildir);
  truncate(buffer, b_lidos);
 }else close(arq_quota);
 if(ttotal >= cache_quota)return 2;
 return 1;
}

//======================================================
// Finaiza o modulo  
char *mod_shutdown(void){
 
 return 0;
}

//======================================================
// Retorna uma mensagem explicando o erro ocorrido      
char *mod_msg_error(void){
 return &msg_error[0];
}


